unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, ShockwaveFlashObjects_TLB, ActiveX, SHDocVw, StdCtrls,
  ExtCtrls, ToolWin, ComCtrls, HttpApp, XPMan, ImgList, ExtDlgs, KDrop,
  Menus, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  IdIntercept, IdLogBase, IdLogEvent, MSHTML, IniFiles;

const
  FINISH_EVENT = WM_APP + $10;
  MISSING_EVENT = WM_APP + $20;
  OS_WINNT = 51;
  OS_WIN2000 = 2000;
  OS_WINXP = 2001;
  OS_WINME = 20002;
  OS_WINVISTA = 2007;
  OS_WIN98 = 1998;
  OS_WIN98SE = 19982;
  OS_WIN95 = 1995;
  OS_UNKNOWN = 0;
  sfBitmap = 0;
  sfPNG = 1;
  sfJPEG = 2;

type
  TPlayermode = (PLAYER_JW,PLAYER_FLOW);
  TSaveFormat = Integer;

  TForm1 = class(TForm)
    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    KAddDrop1: TKAddDrop;
    IdHTTP1: TIdHTTP;
    SaveDialog1: TSaveDialog;
    IdLogEvent1: TIdLogEvent;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton5: TToolButton;
    StatusBar1: TStatusBar;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    PopupMenu1: TPopupMenu;
    FlowPlayer1: TMenuItem;
    JWPlayer1: TMenuItem;
    ToolButton11: TToolButton;
    PopupMenu2: TPopupMenu;
    QueryRenutsu: TMenuItem;
    QueryAutoSave: TMenuItem;
    S1: TMenuItem;
    N1: TMenuItem;
    QueryCapWinHide: TMenuItem;
    ToolButton12: TToolButton;
    procedure ShockwaveFlash1FSCommand(ASender: TObject; const command,
      args: WideString);
    procedure InfoFinish(var Msg:TMessage); message FINISH_EVENT;
    procedure InfoMissing(var Msg:TMessage); message MISSING_EVENT;
    procedure Load(Path:String; Flag:Boolean = true);
    procedure ReFlash;
    procedure ToolButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
      DropFiles: TStrings);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure Download(URL:String; SaveTo:String; Referer:String = '');
    procedure ToolButton4Click(Sender: TObject);
    procedure IdLogEvent1Receive(ASender: TIdConnectionIntercept;
      AStream: TStream);
    procedure FormHint(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure FlowPlayer1Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure LoadSettings;
    procedure SaveSettings;
    procedure RenRegister(Window:TForm);
    procedure RenUnRegister(Window:TForm);
    procedure IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure ToolButton12Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    MovieWidth : Integer;
    MovieHeight : Integer;
    MovieInfogot : Boolean;
    RawMoviePath : String;
    MoviePath : String;
    MissingFlag : Boolean;
    TheLocal : Boolean;
    DLCancel : Boolean;
    Title : String;
    Cookie : String;
    RenWindows : TList;
    FirstShow : Boolean;
  end;

var
  Form1: TForm1;
  ShockwaveFlash1: TShockwaveFlash;
  WindowsVer : Integer;
  ExeDir : String;
  EMPTYSWF : String;
  FLOWPLAYERSWF : String;
  JWPLAYERSWF : String;
  INIFILE : String;
  CAPSAVETO : String;
  CAPSAVEFORMAT : TSaveFormat;
  CAPBASEFILENAME : String;
  PLAYERMODE : TPlayermode;
  SIZESWF : String;
  RenX,RenY : Integer;

implementation

uses Unit2, Unit3, Unit4, Unit5, Unit6, Unit7, Unit8, Unit9, Unit10;

{$R *.dfm}

// Windows̃o[W擾
function GetWindowsVer():Integer;
var
  osInfo: OSVERSIONINFO;
  ver :string;
begin
   Result := OS_UNKNOWN;
   osInfo.dwOSVersionInfoSize:=sizeof(OSVERSIONINFO);
   if GetVersionEx(osInfo) then begin
    with osinfo do begin
     case dwPlatformId of
     VER_PLATFORM_WIN32_NT: //Windows NT/2000/XP
     begin
      if dwMajorVersion <=4 then
        Result := OS_WINNT
      else if (dwMajorVersion =5) and (dwMinorVersion =0) then
        Result := OS_WIN2000
      else if (dwMajorVersion =5) and (dwMinorVersion =1) then
        Result := OS_WINXP
      else if (dwMajorVersion =6) then
        Result := OS_WINVISTA
      else
        Result := OS_UNKNOWN;
        end;
     VER_PLATFORM_WIN32_WINDOWS:  //Windows 9x/ME
        begin
          if (dwMajorVersion =4) and (dwMinorVersion =0) then
            Result := OS_WIN95
          else if (dwMajorVersion =4) and (dwMinorVersion =10) then
          begin
            if szCSDVersion[1] = 'A' then
              Result := OS_WIN98SE
            else
              Result := OS_WIN98;
          end
          else if (dwMajorVersion =4) and (dwMinorVersion =90) then
            Result := OS_WINME
          else
            Result := OS_UNKNOWN;
        end;
      else
        Result := OS_UNKNOWN;
    end; //case
   end; //with
  end
  else
    Result := OS_UNKNOWN;
end;

// 9xňo
function Win9XCheck(OSVer:Integer):Boolean;
begin
      Result := (OSVer = OS_WIN98)or(OSVer = OS_WIN98SE)or(OSVer = OS_WINME)or(OSVer = OS_WINVISTA);
end;

// UTF-8GXP[v
function Uniescape(Src:WideString):String;
begin
      Result := HTTPEncode(UTF8Encode(WideString(Src)));
end;

function LocalPath2GlobalPath(Path:String):String;
begin
      Result := 'file:///' + Uniescape(StringReplace(Path,'\','/',[rfReplaceAll]));
end;

function LANPath2GlobalPath(Path:String):String;
begin
      Result := 'file://'+StringReplace(Path,'\','\\',[rfReplaceAll]);
      Delete(Path,1,2); // \\ 폜
end;

// _E[h[`
procedure TForm1.Download(URL:String; SaveTo:String; Referer:String = '');
var
      Ad1,Ad2 : String;
      Src : TStringList;
      Stream : TFileStream;
begin
      if AnsiPos('http://',URL) = 1 then
      begin
            // Zbg
            IdHttp1.Request.Referer := LocalPath2GlobalPath(Application.ExeName);

            IdHttp1.Request.CustomHeaders.Clear;
            IdHttp1.Request.CustomHeaders.Add('Cookie: '+Form1.Cookie);
            IdHttp1.Request.CustomHeaders.Add('x-flash-version: 9,0,28,0');
            IdHttp1.Request.Connection := 'keep-alive';
            IdHttp1.Request.UserAgent := WebDlg.UserAgent;
            //IdHttp1.Request.ContentType := 'application/x-www-form-urlencoded';
            IdHttp1.Request.Accept := '*/*';

            Src := TStringList.Create;
            Stream := TFileStream.Create(SaveTo,fmCreate);
            try
                  Ad1 := URL;

                  DLCancel := false;
                  ProgressWin.ProgressBar1.Position := 0;
                  ProgressWin.Show;
                  try
                        // Location Ή
                        repeat
                              try
                                    //IdHttp1.Head(Ad1);
                                    //ProgressWin.ProgressBar1.Max := IdHttp1.Response.ContentLength;
                                    Stream.Seek(0,0);
                                    IdHttp1.Get(Ad1,Stream);
                                    //IdHttp1.Post(Ad1, Src, Mem);
                              except
                                    //ShowMessage(InttoStr(IdHttp1.ResponseCode));
                              end;

                              Ad1 := IdHttp1.Response.RawHeaders.Values['Location'];

                        until (Ad1 = '');
                  finally
                        ProgressWin.Close;
                  end;

                  if Stream.Size = 0 then MessageBox(Handle,'ۑɎs܂','G[',MB_OK or MB_ICONERROR);
            finally
                  Src.Free;
                  Stream.Free;
            end;
      end else
      begin
            CopyFile(Pchar(URL),Pchar(SaveTo),False);
      end;
end;

procedure TForm1.InfoMissing(var Msg:TMessage);
begin
      //
end;

procedure TForm1.Load(Path:String; Flag:Boolean = true);
var
      i : Integer;
begin
      MovieInfogot := false;
      MovieWidth := 0;
      MovieHeight := 0;

      RawMoviePath := Path;
      MoviePath := Path;

      {if Win9XCheck(WindowsVer) then
      begin
            MoviePath := Path;
      end else
      begin
            MoviePath := StringReplace(Path,'\','\\',[rfReplaceAll]);
      end;
      }

      if (AnsiPos('http://',Path) = 0) then
      begin
            if (AnsiPos('file://',Path) = 0) then
            begin
                  if (AnsiPos('\\',Path) = 1) then
                  begin
                        //MoviePath := LANPath2GlobalPath(Path);
                  end else
                  begin
                        MoviePath := LocalPath2GlobalPath(Path);
                  end;
            end;
      end;

      // TCY擾 -> ShockwaveFlash1FSCommand 
      ShockWaveFlash1.AllowScriptAccess := 'always';
      ShockWaveFlash1.FlashVars := 'Path='+Uniescape(MoviePath);
      ShockWaveFlash1.Movie := SIZESWF;
end;

procedure TForm1.ShockwaveFlash1FSCommand(ASender: TObject; const command,
  args: WideString);
begin
      // ؂
      if command = 'Finish' then
      begin
            // TCY͎擾łH
            if (MovieWidth > 0)and(MovieHeight > 0) then
            begin
                  // łInfoFinish
                  MovieInfogot := true;
                  PostMessage(Handle,FINISH_EVENT,0,0);
            end;
      end;

      if not MovieInfogot then
      begin
            if command = 'Width' then
            begin
                  MovieWidth := StrtoInt(args);
            end;

            if command = 'Height' then
            begin
                  MovieHeight := StrtoInt(args);
            end;
      end;
end;

procedure TForm1.InfoFinish(var Msg:TMessage);
var
      Vars : WideString;
begin
      case PLAYERMODE of
      PLAYER_FLOW:
            begin
                  ClientWidth := MovieWidth;
                  ClientHeight := MovieHeight + 22 + Panel1.Height;
                  ReFlash;

                  ShockWaveFlash1.AllowScriptAccess := 'never';

                  //if Win9XCheck(WindowsVer) then MoviePath := StringReplace(RawMoviePath,'\','\\',[rfReplaceAll]);
                  if AnsiPos('http://',MoviePath) > 0 then MoviePath := HttpApp.HTTPEncode(MoviePath);
                  if AnsiPos('\\',MoviePath) = 1 then MoviePath := LANPath2GlobalPath(MoviePath);

                  // ϐZbgăA_v^ǂݍ
                  Vars := 'config={ videoFile: '''+MoviePath+''',loop:false,showFullScreenButton: false}';
                  ShockWaveFlash1.FlashVars := Vars;
                  ShockWaveFlash1.LoadMovie(0,FLOWPLAYERSWF);
            end;
      PLAYER_JW:
            begin
                  ClientWidth := MovieWidth;
                  ClientHeight := MovieHeight + 20 + Panel1.Height;
                  Reflash;

                  if AnsiPos('http://',MoviePath) > 0 then MoviePath := HttpApp.HTTPEncode(MoviePath);
                  //if AnsiPos('\\',MoviePath) = 1 then MoviePath := LANPath2GlobalPath(MoviePath);

                  ShockWaveFlash1.LoadMovie(0,JWPLAYERSWF);
                  ShockWaveFlash1.SetVariable('type','flv');
                  ShockWaveFlash1.SetVariable('autostart','true');
                  ShockWaveFlash1.SetVariable('file',MoviePath);
                  ShockWaveFlash1.SetVariable('showicons','false');
                  ShockWaveFlash1.SetVariable('overstretch','none');
            end;
      end;
end;

procedure TForm1.ReFlash;
begin
      if Assigned(ShockwaveFlash1) then
      begin
            ShockWaveFlash1.Stop;
            ShockWaveFlash1.Parent := nil;
            ShockWaveFlash1.LoadMovie(0,EMPTYSWF);
            ShockWaveFlash1.FlashVars := '';
            ShockWaveFlash1.Free;
      end;

      ShockWaveFlash1 := TShockWaveFlash.Create(nil);
      ShockWaveFlash1.Name := 'ShockWaveFlash1';
      ShockWaveFlash1.Parent := nil;
      ShockWaveFlash1.Width := ClientWidth;
      ShockWaveFlash1.Height := ClientHeight-Panel1.Height;
      ShockWaveFlash1.Parent := Form1;
      ShockWaveFlash1.OnFSCommand := ShockwaveFlash1FSCommand;
      ShockWaveFlash1.LoadMovie(0,EMPTYSWF);
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
      if OpenDialog1.Execute then
      begin
            ReFlash;
            Load(OpenDialog1.FileName);
            Title := ExtractFileName(OpenDialog1.FileName);
      end;
end;

procedure TForm1.LoadSettings;
var
      Ini : TMemIniFile;
      Section : String;
begin
      ini := TMemIniFile.Create(INIFILE);
      try
            Section := 'Capture';
            Unit1.CAPSAVETO := ini.ReadString(Section,'Path',ExeDir+'\Capture');
            Unit1.CAPBASEFILENAME := ini.ReadString(Section,'Base','FLVStill');
            Unit1.CAPSAVEFORMAT := ini.ReadInteger(Section,'Format',sfBitmap);
      finally
            ini.Free;
      end;
end;

procedure TForm1.SaveSettings;
var
      Ini : TMemIniFile;
      Section : String;
begin
      ini := TMemIniFile.Create(INIFILE);
      try
            Section := 'Capture';
            ini.WriteString(Section,'Path',Unit1.CAPSAVETO);
            ini.WriteString(Section,'Base',Unit1.CAPBASEFILENAME);
            ini.WriteInteger(Section,'Format',Unit1.CAPSAVEFORMAT);
      finally
            ini.Free;
      end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
      Ini : TMemIniFile;
begin
      ReFlash;
      Application.OnHint := FormHint;
      WindowsVer := GetWindowsVer; // pX`̐U蕪Ăc

      // pX֌W
      ExeDir := ExtractFileDir(Application.ExeName);
      EMPTYSWF := ExeDir+'\Empty.swf';
      FLOWPLAYERSWF := ExeDir+'\FlowPlayer.swf';
      JWPLAYERSWF := ExeDir+'\flvplayer.swf';
      SIZESWF := ExeDir + '\Size.swf';
      INIFILE := ExeDir + '\Setting.ini';

      LoadSettings;

      RenX := 10;
      RenY := 10;

      RenWindows := TList.Create;
      FirstShow := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
      i : Integer;
begin
      if Assigned(ShockWaveFlash1) then
      begin
            ShockWaveFlash1.Parent := nil;
            ShockWaveFlash1.LoadMovie(0,EMPTYSWF);
            ShockWaveFlash1.Free;
      end;

      SaveSettings;

      for i := 0 to RenWindows.Count-1 do
      begin
            TForm(RenWindows[i]).Free;
      end;

      RenWindows.Free;
end;

procedure TForm1.FormHint(Sender: TObject);
begin
      StatusBar1.Panels.Items[0].Text := Application.Hint;
end;

procedure TForm1.KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
  DropFiles: TStrings);
begin
      ReFlash;
      Load(DropFiles[0]);
end;

procedure TForm1.ToolButton3Click(Sender: TObject);

function CreateFileName:String;
var
      Base,FileName,Ext : String;
      i : Integer;
begin
      Base := IncludeTrailingPathDelimiter(CAPSAVETO) + CAPBASEFILENAME;

      case CAPSAVEFORMAT of
            sfBitmap : Ext := 'bmp';
            sfPNG : Ext := 'png';
            sfJPEG : Ext := 'jpg';
      end;

      i := 1;
      repeat
            FileName := Format('%s(%.03d).%s',[Base,i,Ext]);
            Inc(i);
      until (not FileExists(FileName));

      Result := FileName;
end;

var
      bmp: TBitmap;
      FileName : String;
begin
      if Assigned(ShockWaveFlash1) then
      begin
            bmp := TBitmap.Create;
            try
                  bmp.Width := MovieWidth;
                  bmp.Height := MovieHeight;

                  OleDraw(
                        ShockWaveFlash1.ControlInterface,
                        DVASPECT_CONTENT,
                        bmp.Canvas.Handle,
                        Rect(0, 0, bmp.Width, bmp.Height)
                  );

                  // t@C
                  if QueryAutoSave.Checked then
                  begin
                        FileName := CreateFileName;
                        ForceDirectories(ExtractFileDir(FileName));
                  end;

                  if QueryRenutsu.Checked then
                  begin
                        RenDlg := TRenDlg.Create(nil);
                        RenDlg.Left := RenX+10;
                        RenDlg.Top := RenY+10;
                        RenDlg.Image1.Picture.Bitmap.Assign(bmp);
                        RenDlg.ClientWidth := bmp.Width;
                        RenDlg.ClientHeight := bmp.Height;
                        RenDlg.MoveEvent;

                        RenRegister(RenDlg);

                        // I[gZ[u
                        if QueryAutoSave.Checked then RenDlg.Image1.Picture.SaveToFile(FileName);

                        if (not QueryCapWinHide.Checked) then RenDlg.Show
                        else begin
                              RenUnRegister(RenDlg);
                              RenDlg.Release;
                        end;
                  end else
                  begin
                        //CapDlg := TCapDlg.Create(Form1);
                        CapDlg.Image1.Picture.Bitmap.Assign(bmp);
                        CapDlg.ClientWidth := bmp.Width;
                        CapDlg.ClientHeight := bmp.Height;

                        // I[gZ[u
                        if QueryAutoSave.Checked then CapDlg.Image1.Picture.SaveToFile(FileName);

                        if (not QueryCapWinHide.Checked) then CapDlg.Show;
                  end;
            finally
                  bmp.Free;
            end;
      end;

end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
      WebDlg.Showmodal;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
      SaveDialog1.FileName := Title;
      if (RawMoviePath <> '') and SaveDialog1.Execute then
      begin
            Download(RawMoviePath, SaveDialog1.FileName, WebDlg.Referer);
      end;
end;

procedure TForm1.IdLogEvent1Receive(ASender: TIdConnectionIntercept;
  AStream: TStream);
begin
      ProgressWin.ProgressBar1.StepBy(AStream.Size);
      //Application.ProcessMessages;
      //if DLCancel then IdHttp1.Disconnect;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
      FreedomWin.Show;
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
      if RawMoviePath <> '' then
      begin
            if AnsiPos('http://',RawMoviePath) > 0 then
            begin
                  WebDlg.LoadComplete := false;
                  WebDlg.WebBrowser1.Navigate(WebDlg.LastNavigate);
                  while not(WebDlg.LoadComplete) do Application.ProcessMessages;
                  WebDlg.WebBrowser1.Navigate('about:blank');
            end;

            ReFlash;
            Load(RawMoviePath);
      end;
end;

procedure TForm1.ToolButton8Click(Sender: TObject);
begin
      VersionDlg := TVersionDlg.Create(nil);
      try
            VersionDlg.BitBtn1.Visible := true;
            VersionDlg.Showmodal;
      finally
            VersionDlg.Release;
      end;
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
var
      FLVPath : String;
begin
      FLVPath := RawMoviePath;
      if InputQuery('FLVURLړ','URL',FLVPath) then
      begin
            Load(FLVPath);
      end;
end;

procedure TForm1.FlowPlayer1Click(Sender: TObject);
begin
      if JWPlayer1.Checked then PLAYERMODE := PLAYER_JW;
      if FlowPlayer1.Checked then PLAYERMODE := PLAYER_FLOW;
end;

procedure TForm1.ToolButton10Click(Sender: TObject);
begin
      case PlayerMode of
            PLAYER_JW: ShowMessage('Current player is JW Player');
            PLAYER_FLOW: ShowMessage('Current player is FlowPlayer');
      end;
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
begin
      SendMsgDlg.showmodal;
end;

procedure TForm1.S1Click(Sender: TObject);
var
      key : char;
begin
      // ݒ̃[h
      CapSetting := TCapSetting.Create(nil);
      try
            CapSetting.Edit1.Text := Unit1.CAPSAVETO;
            CapSetting.Edit2.Text := Unit1.CAPBASEFILENAME;
            CapSetting.ComboBox1.ItemIndex := Unit1.CAPSAVEFORMAT;
            key := #13; CapSetting.Edit1keyPress(nil,key);

            CapSetting.showmodal;

            // ݒ̕ۑ
            Unit1.CAPSAVETO := CapSetting.Edit1.Text;
            Unit1.CAPBASEFILENAME := CapSetting.Edit2.Text;
            Unit1.CAPSAVEFORMAT := CapSetting.ComboBox1.ItemIndex;
      finally
            CapSetting.Release;
      end;
end;

// AʃEChEXg֒ǉ
procedure TForm1.RenRegister(Window:TForm);
begin
      RenWindows.Add(Window)
end;

// AʃEChEXg폜
procedure TForm1.RenUnRegister(Window:TForm);
var
      i : Integer;
begin
      i := RenWindows.IndexOf(Window);
      if i >= 0 then RenWindows.Delete(i);
end;

procedure TForm1.IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
      ProgressWin.ProgressBar1.Max := IdHttp1.Response.ContentLength;
      Application.ProcessMessages;
      if DLCancel then IdHttp1.Disconnect;
end;

procedure TForm1.ToolButton12Click(Sender: TObject);
begin
      ExtractMP3Dlg.showmodal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
      if FirstShow then
      begin
            if FileExists(ParamStr(1)) then
            begin
                  ReFlash;
                  Load(ParamStr(1));
            end;

            FirstShow := false;
      end;
end;

initialization
      CoInitialize(nil);
      OleInitialize(nil);
finalization
      CoUnInitialize;
      OleUnInitialize;
      //ExitProcess(0);

end.
