unit Unit10;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, KDrop, Buttons;

type

  TFLVHeader = packed record
      Signature : Array [0..2] of char;
      Version : Byte;
      Flags : Byte;
      Offset : Integer;
  end;

  TExtractMP3Dlg = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    KAddDrop1: TKAddDrop;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
      DropFiles: TStrings);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  ExtractMP3Dlg: TExtractMP3Dlg;

implementation

{$R *.dfm}

// rbOGfBA烊gGfBA(24bit)
function BE2LE(Src:Integer):Integer;
var
      p : PByte;
      i : Integer;
      Data : Array [0..3] of Byte;
begin
      p := Addr(Src);

      for i := 3 downto 1 do
      begin
            Data[i] := p^;
            Inc(p);
      end;

      Data[0] := 00;

      Result := Integer(Data) shr 8;
end;

// mp3o[`
procedure ExtractAudio(Src,DestAudio:String; OverwriteConfirm:Boolean = false);
var
      Reader : TFileStream;
      Writer : TFileStream;
      Header : TFLVHeader;
      PreviousTagSize : Integer;
      TagType : Byte;
      BodyLength : Integer;
      Timestamp : Integer;
      TimestampExtended : Byte;
      StreamId : Integer;
      Buffer,p : PByte;
      AudioFlag : Byte;
begin
      if OverwriteConfirm and FileExists(DestAudio) then
      begin
            if MessageBox(
                  Application.Handle,
                  PChar(ExtractFileName(DestAudio)+' ㏑܂H'),
                  'mF',
                  MB_YESNO or MB_ICONINFORMATION
            ) = ID_NO then exit;
      end;

      Reader := TFileStream.Create(Src,fmOpenRead);
      if (DestAudio <> '') then Writer := TFileStream.Create(DestAudio,fmCreate);
      try
            Reader.Read(Header,sizeof(Header));

            while (Reader.Position < Reader.Size) do
            begin
                  BodyLength := 0;
                  Timestamp := 0;
                  StreamId := 0;

                  Reader.Read(PreviousTagSize,4);
                  Reader.Read(TagType,1);
                  Reader.Read(BodyLength,3);
                  BodyLength := BE2LE(BodyLength);
                  Reader.Read(Timestamp,3);
                  Reader.Read(TimestampExtended,1);
                  Reader.Read(StreamId,3);

                  if TagType = $08 then
                  begin
                        Reader.Read(AudioFlag,1);

                        GetMem(Buffer,BodyLength);
                        p := Buffer;
                        try
                              Reader.Read(p^,BodyLength-1);
                              if Assigned(Writer) then Writer.Write(p^,BodyLength-1);
                        finally
                              FreeMem(Buffer);
                        end;
                  end else
                  begin
                        Reader.Seek(BodyLength,soFromCurrent);
                  end;
            end;
      finally
            Reader.Free;
            if Assigned(Writer) then Writer.Free;
      end;
end;


procedure TExtractMP3Dlg.Button1Click(Sender: TObject);
var
      StrDir : String;
begin
      if SelectDirectory('tH_I','',StrDir) then
      begin
            Edit1.Text := StrDir;
            RadioButton2.Checked := true;
      end;
end;

procedure TExtractMP3Dlg.Button2Click(Sender: TObject);
begin
      if OpenDialog1.Execute then
      begin
            Memo1.Lines.AddStrings(OpenDialog1.Files);
      end;
end;

procedure TExtractMP3Dlg.KAddDrop1DropFiles(Sender: TObject;
  Target: TWinControl; DropFiles: TStrings);
begin
      Memo1.Lines.AddStrings(DropFiles);
end;

procedure TExtractMP3Dlg.BitBtn1Click(Sender: TObject);
var
      i : Integer;
      Src : String;
      Dest : String;
begin
      for i := 0 to Memo1.Lines.Count-1 do
      begin
            Src := Memo1.Lines[i];

            if RadioButton1.Checked then
            begin
                  Dest := ChangeFileExt(Src,'.mp3');
            end else
            begin
                  Dest := IncludeTrailingPathDelimiter(Edit1.Text) + ChangeFileExt(ExtractFileName(Src),'.mp3');
            end;

            // fBNg΍
            if not DirectoryExists(ExtractFileDir(Dest)) then
            begin
                  ForceDirectories(ExtractFileDir(Dest));
            end;

            ExtractAudio(Src,Dest,CheckBox1.Checked);
      end;
end;

end.
